#ifndef __CONV2BMP_H__
#define __CONV2BMP_H__


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned int u_int;
typedef unsigned long u_long;

typedef long LONG;
typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;

typedef enum { FALSE, TRUE } bool;

//---------------------------------------------------------------------------

typedef struct {
    int width;
    int height;

    int xoffset;
    int yoffset;

    int rwidth;
    int rheight;

    u_char *data;

//    u_short *hsb_data;

    int transparent;
    int black;

    u_char palette[256][3];
    int palette_num;
} Image;


static struct {
  char name[16];
  int width;
  int height;
  int pal;
} sdt_list[] = {
  {"OP1W.SDT", 336, 400, 1}, /*  */
  {"OP2W.SDT", 448, 512, 1}, /*    */
  {"OP3W.SDT", 448, 512, 2}, /*    */
  {"OP4W.SDT", 336, 400, 2}, /*  */
  {"OP2_KM_W.SDT", 1280, 400, 0}, /* e */
};


/*
 * I[vjÕpbg 
 */
static u_char pal[][16][3] = {
  /* uv */
  {{51,0,85},
   {34,0,51},
   {17,0,34},
   {0,0,17},
   
   {153,102,187},
   {85,51,119},
   {85,51,119},
   {85,51,119},
   
   {119,68,170},
   {68,34,102},
   {68,34,102},
   {68,34,102},
   
   {85,34,153},
   {34,17,85},
   {34,17,85},
   {34,17,85},
  },

  /*  &  */
  {{0, 0, 0},
   {0, 192, 192},
   {0, 128, 128},
   {0, 64, 64},
   
   {192, 0, 0},
   {192, 192, 192},
   {192, 128, 128},
   {192, 64, 64},
   
   {128, 0, 0},
   {128, 192, 192},
   {128, 128, 128},
   {128, 64, 64},
   
   {64, 0, 0},
   {64, 192, 192},
   {64, 128, 128},
   {64, 64, 64},
  },
  /*  &  */
  {{0, 0, 0},
   {192, 0, 0},
   {128, 0, 0},
   {64, 0, 0},
   
   {0, 96, 192},
   {192, 96, 192},
   {64, 96, 192},
   {128, 96, 192},
   
   {0, 64, 128},
   {192, 64, 128},
   {128, 64, 128},
   {64, 64, 128},
   
   {0, 32, 64},
   {192, 32, 64},
   {128, 32, 64},
   {64, 32, 64},
  }
};


#pragma pack(1)


typedef struct tagBITMAPFILEHEADER {
  WORD bfType; 
  DWORD bfSize; 
  WORD bfReserved1; 
  WORD bfReserved2; 
  DWORD bfOffBits; 
} BITMAPFILEHEADER;


typedef struct tagBITMAPINFOHEADER { 
  DWORD biSize; 
  LONG biWidth; 
  LONG biHeight; 
  WORD biPlanes; 
  WORD biBitCount;
  DWORD biCompression; 
  DWORD biSizeImage; 
  LONG biXPelsPerMeter; 
  LONG biYPelsPerMeter; 
  DWORD biClrUsed; 
  DWORD biClrImportant; 
} BITMAPINFOHEADER; 


typedef struct tagRGBQUAD {
   BYTE   rgbBlue;
   BYTE   rgbGreen;
   BYTE   rgbRed;
   BYTE   rgbReserve;
} RGBQUAD;

#pragma pack()

//---------------------------------------------------------------------------
u_char* open_buf(const char* pName);
void    save_img(Image* img, const char* pName);
bool    is_extension(char* pName, char* pExt);

Image*  lvnsimage_load_lfg(const u_char *data, Image *over);
Image*  lvnsimage_load_sdt(const u_char *data, const char *name);

void    leafpack_lzs(const u_char * loadBuf, u_char * saveBuf, size_t size);
void    leafpack_lzs2(const u_char * pLoadBuff, u_char * pSaveBuff, size_t DataSize);

Image*  image_new(int w, int h, int x, int y);
void    image_delete(Image *img);
void    image_fix_color(Image *img);


#endif
