#ifndef __IMG_H__
#define __IMG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define IMG_MAX_FILE_LEN					14

#define IMG_BG_STR							"S%02d.img"
#define IMG_CHR_STR							"C%02X.img"
#define IMG_HVS_STR							"H%02d.img"
#define IMG_VIS_STR							"V%02d.img"


enum {
	IMG_EFFECT_NONE,						// 0.Ȃ
	IMG_EFFECT_NO_EFFECT,					// 1.ȂɂȂ
	IMG_EFFECT_NORMAL,						// 2.P\
	IMG_EFFECT_FADE_MASK,					// 3.}XNtF[h
	IMG_EFFECT_WIPE_TTOB,					// 4.ォ烏Cv
	IMG_EFFECT_WIPE_LTOR,					// 5.烏Cv
	IMG_EFFECT_FADE_BLACK,					// 6.Palette tF[h(Black)
	IMG_EFFECT_WIPE_MASK_LTOR,				// 7.烏Cv(}XN)
	IMG_EFFECT_FADE_SQUARE,					// 8.Ђ`tF[h
	IMG_EFFECT_WIPE_SQUARE_LTOR,			// 9.Ђ`Cv
	IMG_EFFECT_SLIDE_LTOR,					// 10.cXCh
	IMG_EFFECT_SLANTTILE,					// 11.΂ꉡUCNXCh
	IMG_EFFECT_GURUGURU,					// 12.邮
	IMG_EFFECT_VERTCOMPOSITION,				// 13.cł݂͂
	IMG_EFFECT_CIRCLE_SHRINK,				// 14.Sɂ
	IMG_EFFECT_LEFT_SCROLL,					// 15.ɃXN[
	IMG_EFFECT_TOP_SCROLL,					// 16.ɃXN[
	IMG_EFFECT_RAND_RASTER,					// 17._s\
	IMG_EFFECT_BLOOD,						// 18.炾

	// ǉ
	IMG_EFFECT_FADE_WHITE,					// 19.White tF[h
	IMG_EFFECT_TEXT,						// 20.bZ[W tF[h
	IMG_EFFECT_SPECIAL0,					// 21.Wave ^CgSp
	IMG_EFFECT_SPECIAL1,					// 22.Aj[Vpi & j
	IMG_EFFECT_SPECIAL2,					// 23.Aj[Vpi & j
	IMG_EFFECT_SPECIAL3,					// 24.^Cg\p
};

enum {
	IMG_CHR_TYPE_LEFT,
	IMG_CHR_TYPE_RIGHT,
	IMG_CHR_TYPE_MID,
	IMG_CHR_TYPE_ALL,
};

enum {
	IMG_BG_TYPE_BACK,
	IMG_BG_TYPE_VISUAL,
	IMG_BG_TYPE_HCG,

	IMG_BG_TYPE_BLACK,						// F
	IMG_BG_TYPE_WHITE,						// F
	IMG_BG_TYPE_SPECIAL,					// Ή
};

//---------------------------------------------------------------------------

// 摜t@C̃wb_
typedef struct {
	s16  cx;
	s16  cy;
} __PACKED ST_IMG_HEADER;


// 摜Ǘp
typedef struct {
	bool isDraw;
	char fname[IMG_MAX_FILE_LEN];
	u16  type;
	s16  sx;
	s16  sy;
	s16  cx;
	s16  cy;
	u16* pDat;
} ST_CONTROL;


typedef struct {
	u16  step;

	// wi{LN^Ǘ
	ST_CONTROL bg;
	ST_CONTROL chr[3];

	// ʑJځiClearj
	bool isClear;
	u16  clearType;
	u16  clearNum;

	// ʑJځiUpdatej
	bool isUpdate;
	u16  updateType;
	u16  updateNum;

	// ʑJځieLXgj
	bool isTextClear;
	bool isText;							// eLXg̕\L
	u16  textFadeNum;						// \̃tF[h
	u16  textWaitNum;						// eLXg\̃EFCg

} ST_IMG;


//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void);
EWRAM_CODE void ImgExec(void);
EWRAM_CODE void ImgExecTextClear(void);
IWRAM_CODE void ImgExecClear(void);
IWRAM_CODE void ImgExecUpdate(void);
EWRAM_CODE void ImgExecBg(void);
EWRAM_CODE void ImgExecChr(void);

EWRAM_CODE void ImgSetBg(char* pStr);
EWRAM_CODE void ImgSetBg2(u16 no);
EWRAM_CODE void ImgSetBg3(char* pStr, s16 sx, s16 sy);
EWRAM_CODE void ImgSetBg4(char* pStr, s16 sx, s16 sy);
EWRAM_CODE void ImgSetBgV(u16 no);
EWRAM_CODE void ImgSetBgH(u16 no);
EWRAM_CODE void ImgSetBgClear(void);
EWRAM_CODE void ImgSetBgClow(char* pStr);

EWRAM_CODE void ImgSetChr(char* pStr, u16 type);
EWRAM_CODE void ImgSetChr2(u16 no, u16 type);
EWRAM_CODE void ImgSetChrClear(u16 type);

EWRAM_CODE void ImgSetEffectClear(u16 type);
EWRAM_CODE void ImgSetEffectClear2(u16 type, u16 num);
EWRAM_CODE void ImgSetEffectUpdate(u16 type);
EWRAM_CODE void ImgSetEffectUpdate2(u16 type, u16 num);

EWRAM_CODE u16  ImgGetTextFadeNum(void);
EWRAM_CODE u16  ImgGetTextWaitNum(void);
EWRAM_CODE void ImgSetTextFadeNum(u16 num);
EWRAM_CODE void ImgSetTextWaitNum(u16 num);

EWRAM_CODE bool ImgIsEnd(void);
EWRAM_CODE bool ImgIsText(void);


#ifdef __cplusplus
}
#endif
#endif
