#include "script2.h"
#include "script.h"
#include "anime.h"
#include "img.h"
#include "bgm.h"
#include "siori.h"
#include "history.h"
#include "text.h"


// script2.c
// uvp[T{


//---------------------------------------------------------------------------
ST_SCRIPT_PARSE_TABLE ScriptParseTable[SCRIPT_MAX_PARSE_CNT] = {
	// Cxg
	{ 0x20, (void*)ScriptExecParseEnd        },
	{ 0x24, (void*)ScriptExecParseJump       },
	{ 0x25, (void*)ScriptExecParseSelect     },
	{ 0x27, (void*)ScriptExecParseSelectPrev },
	{ 0x41, (void*)ScriptExecParseIf         },
	{ 0x42, (void*)ScriptExecParseIf2        },
	{ 0x4b, (void*)ScriptExecParseSetFlag    },
	{ 0x51, (void*)ScriptExecParseMsg        },
	{ 0x52, (void*)ScriptExecParseSkip       },
	{ 0x94, (void*)ScriptExecParseEnding     },
	{ 0x95, (void*)ScriptExecParseEnding2    },
	{ 0x96, (void*)ScriptExecParseEnding3    },

	// bZ[W
	{ 0x30, (void*)ScriptExecParseBg         },
	{ 0x31, (void*)ScriptExecParseSkip2      },
	{ 0x34, (void*)ScriptExecParseBgClear    },
	{ 0x35, (void*)ScriptExecParseSkip2      },
	{ 0x36, (void*)ScriptExecParseNoVisual   },
	{ 0x37, (void*)ScriptExecParseNoChr      },
	{ 0x38, (void*)ScriptExecParseEffect     },
	{ 0x39, (void*)ScriptExecParseEffect2    },
	{ 0x3a, (void*)ScriptExecParseSkip2      },
	{ 0x3b, (void*)ScriptExecParseSkip2      },
	{ 0x3c, (void*)ScriptExecParseSkip2      },

	{ 0x60, (void*)ScriptExecParseSkip       },
	{ 0x61, (void*)ScriptExecParseSkip       },
	{ 0x62, (void*)ScriptExecParseSkip2      },
	{ 0x63, (void*)ScriptExecParseSkip2      },
	{ 0x64, (void*)ScriptExecParseSkip       },
	{ 0x65, (void*)ScriptExecParseSkip       },
	{ 0x66, (void*)ScriptExecParseSkip       },
	{ 0x67, (void*)ScriptExecParseSkip2      },
	{ 0x68, (void*)ScriptExecParseSkip2      },
	{ 0x69, (void*)ScriptExecParseSkip       },
	{ 0x6a, (void*)ScriptExecParseSkip       },
	{ 0x6b, (void*)ScriptExecParseSkip2      },
	{ 0x6c, (void*)ScriptExecParseSkip2      },

	{ 0x80, (void*)ScriptExecParseBgm        },
	{ 0x81, (void*)ScriptExecParseBgmFade    },
	{ 0x82, (void*)ScriptExecParseBgmStop    },
	{ 0x84, (void*)ScriptExecParseBgmNext    },
	{ 0x85, (void*)ScriptExecParseBgmWait    },
	{ 0x87, (void*)ScriptExecParseBgm2       },

	{ 0xa0, (void*)ScriptExecParsePcmLoad    },
	{ 0xa1, (void*)ScriptExecParsePcmStop    },
	{ 0xa2, (void*)ScriptExecParsePcm        },
	{ 0xa3, (void*)ScriptExecParsePcmWait    },
	{ 0xa6, (void*)ScriptExecParseSkip       },

	{ 0xaf, (void*)ScriptExecParseMsgEnd     },
	{ 0xb0, (void*)ScriptExecParseNewLine    },
	{ 0xb2, (void*)ScriptExecParseWaitKey    },
	{ 0xb3, (void*)ScriptExecParseWaitPage   },
	{ 0xb6, (void*)ScriptExecParseWaitStr    },
	{ 0xb7, (void*)ScriptExecParseWait       },
	{ 0xb9, (void*)ScriptExecParseOffset     },
	{ 0xbb, (void*)ScriptExecParseFlash      },
	{ 0xbc, (void*)ScriptExecParseShake      },
	{ 0xbd, (void*)ScriptExecParseBg2        },
	{ 0xbe, (void*)ScriptExecParseBg2        },
	{ 0xbf, (void*)ScriptExecParseBgV        },
	{ 0xc0, (void*)ScriptExecParseBgH        },
	{ 0xc1, (void*)ScriptExecParseChr        },
	{ 0xc2, (void*)ScriptExecParseChr        },
	{ 0xc3, (void*)ScriptExecParseChr2       },
	{ 0xc4, (void*)ScriptExecParseBgAndChr   },
	{ 0xc6, (void*)ScriptExecParseChrAll     },
	{ 0xc8, (void*)ScriptExecParseSkip3      },
	{ 0xc9, (void*)ScriptExecParseSkip       },
	{ 0xca, (void*)ScriptExecParseAniClaw    },
	{ 0xcb, (void*)ScriptExecParseSkip       },
	{ 0xcc, (void*)ScriptExecParseUneUne     },
	{ 0xcd, (void*)ScriptExecParseAniBlood   },
};

//---------------------------------------------------------------------------
extern ST_SCRIPT Script;


//---------------------------------------------------------------------------
IWRAM_CODE void ScriptExecParse(void)
{
	if(Script.act == SCRIPT_ACT_EVENT)
	{
		Script.pEventOld = Script.pCur;
	}
	else
	{
		Script.pMsgOld = Script.pCur;
	}


	Script.isLoop = TRUE;
	u8  op;
	u16 i;

	do
	{
		if(*Script.pCur < 0x20)
		{
			ScriptExecParseText();
		}

		op = *Script.pCur++;

		for(i=0; i<SCRIPT_MAX_PARSE_CNT; i++)
		{
			if(op == ScriptParseTable[i].op)
			{
				TRACEOUT("--------------------------------\n");
				TRACEOUT("[Parse: 0x%02x]\n", op);

				ScriptParseTable[i].pFunc();
				break;
			}
		}
		_ASSERT(i < SCRIPT_MAX_PARSE_CNT);


	} while(Script.isLoop == TRUE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEnd(void)
{
	TRACEOUT("[ubNI]\n");

	BgmStop();
	HistoryInit();
	TextInit();

	Script.isNext = FALSE;
	Script.isLoop = FALSE;
	ScriptSetAct(SCRIPT_ACT_END);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseJump(void)
{
	u8 scnNo   = *Script.pCur++;
	u8 eventNo = *Script.pCur++;

	TRACEOUT("[Wv: %03d.SCN Block %d]\n", scnNo, eventNo);

	ScriptSetScn(scnNo);
	ScriptSetEvent(eventNo);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSelect(void)
{
	TRACEOUT("[I]\n");

	ScriptSetAct(SCRIPT_ACT_SELECT);
	Script.isNext = FALSE;
	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSelectPrev(void)
{
	TRACEOUT("[ȎIɖ߂}[Nʒu]\n");

	SioriSavePrev();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseIf(void)
{
	u8 no     = ScriptGetMapFlag(*Script.pCur++);
	u8 src    = ScriptGetFlag(no);
	u8 dst    = *Script.pCur++;
	u8 offset = *Script.pCur++;

	TRACEOUT("[if no:0x%02x val:0x%02x == 0x%02x pc += 0x%02x]\n", no, src, dst, offset);

	if(src == dst)
	{
		Script.pCur += offset;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseIf2(void)
{
	u8 no     = ScriptGetMapFlag(*Script.pCur++);
	u8 src    = ScriptGetFlag(no);
	u8 dst    = *Script.pCur++;
	u8 offset = *Script.pCur++;

	TRACEOUT("[if(ے) no:0x%02x val:0x%02x != 0x%02x pc += 0x%02x]\n", no, src, dst, offset);

	if(src != dst)
	{
		Script.pCur += offset;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSetFlag(void)
{
	u8 flagNo = ScriptGetMapFlag(*Script.pCur++);
	u8 val    = *Script.pCur++;

	TRACEOUT("[tO̒lݒ: 0x%02x = 0x%02x]\n", flagNo, val);

	ScriptSetFlag(flagNo, val);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseMsg(void)
{
	_ASSERT(Script.act == SCRIPT_ACT_EVENT);


	u8 msgNo = *Script.pCur++;

	TRACEOUT("[bZ[W: %d]\n", msgNo);

	Script.pEventOld = Script.pCur;
	Script.isLoop = FALSE;

	ScriptSetMsg(msgNo);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEnding(void)
{
	TRACEOUT("[GfBO֌W ]\n");
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEnding2(void)
{
	u8 bgmNo = ScriptGetMapBgm(*Script.pCur++);

	TRACEOUT("[GfBOBGMݒ & N:%02x %d]\n", bgmNo);

	SioriSavePrev();

	TextSetClearNoBuf();
	BgmPlay(bgmNo, TRUE);
	AnimeSetType(ANIME_TYPE_ED, TRUE);

	ScriptSetAct(SCRIPT_ACT_ANIME);
	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEnding3(void)
{
	u8 no = *Script.pCur++;

	TRACEOUT("[GfBOԍݒ 0x%02x]\n", no);

	ScriptSetFlagEnd(no, 1);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBg(void)
{
	u8 bgNo = ScriptGetMapBg(*Script.pCur++);

	TRACEOUT("[wî݃[h: S%02d.img]\n", bgNo);
	ImgSetBg2(bgNo);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSkip2(void)
{
	TRACEOUT("[2]\n");

	Script.pCur++;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgClear(void)
{
	u8 no = ScriptGetMapEffect(*Script.pCur++);

	TRACEOUT("[ʏ?: %02d]\n", no);

	ImgSetEffectClear(no);
	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseNoVisual(void)
{
	u8 no = *Script.pCur++;

	TRACEOUT("[Visual[h: V%02d.img]\n", no);

	ImgSetBgV(no);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseNoChr(void)
{
	u8 pos   = *Script.pCur++;
	u8 chrNo = *Script.pCur++;

	TRACEOUT("[LN^[h: C%02X.img %02x]\n", chrNo, pos);

	ImgSetChr2(chrNo, pos);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEffect(void)
{
	u8 no = *Script.pCur++;
	Script.pCur++;				// 1Bytej܂

	TRACEOUT("[ڕ\\ %d]\n", no);

	switch(no)
	{
	case 0:
	case 1:
		ImgSetEffectUpdate(IMG_EFFECT_NORMAL);
		BgmPlayNext();
		break;

	case 2:
		ImgSetEffectUpdate(IMG_EFFECT_FADE_MASK);
		BgmPlayNext();
		break;

	default:
		SystemError("[Err] ScriptExecParseEffect no=%d\n", no);
		break;
	}

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseEffect2(void)
{
	u8 no = ScriptGetMapEffect(*Script.pCur++);

	TRACEOUT("[\\: %02d]\n", no);

	ImgSetEffectUpdate(no);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSkip(void)
{
	TRACEOUT("[1]\n");
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgm(void)
{
	u8 bgmNo = ScriptGetMapBgm(*Script.pCur++);

	TRACEOUT("[BGM Jn: tr_%03d.8ad]\n", bgmNo);

	BgmPlay(bgmNo, TRUE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgmFade(void)
{
	TRACEOUT("[BGM tF[hAEg]\n");

	BgmStopOut();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgmStop(void)
{
	TRACEOUT("[BGM ~]\n");

	BgmStopOut();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgmNext(void)
{
	u8 bgmNo = ScriptGetMapBgm(*Script.pCur++);

	TRACEOUT("[BGM ֘AJn?: tr_%03d.8ad]\n", bgmNo);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgmWait(void)
{
	TRACEOUT("BGM tF[hI҂]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgm2(void)
{
	u8 bgmNo = ScriptGetMapBgm(*Script.pCur++);

	TRACEOUT("[BGM Jn(Next): tr_%03d.8ad]\n", bgmNo);

	BgmSetNext(bgmNo, TRUE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParsePcmLoad(void)
{
	u8 no = *Script.pCur++;

	TRACEOUT("[PCMǂݍ KZ_VD%02d.P16]\n", no);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParsePcmStop(void)
{
	TRACEOUT("[PCM]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParsePcm(void)
{
	u8 no = *Script.pCur++;
	Script.pCur++;				// 1Bytej܂

	TRACEOUT("[PCMĐ KZ_VD%02d.P16]\n", no);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParsePcmWait(void)
{
	TRACEOUT("[PCM~҂]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseMsgEnd(void)
{
	_ASSERT(Script.act == SCRIPT_ACT_MSG);

	TRACEOUT("[bZ[WI]\n");

	Script.pCur = Script.pEventOld;
	ScriptSetAct(SCRIPT_ACT_EVENT);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseNewLine(void)
{
	TRACEOUT("[s]\n");

	// sPC98Windows̉ʃTCYɍ킹ĔzuĂׁA
	// GBAł͖܂
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseWaitKey(void)
{
	TRACEOUT("[L[͑҂]\n");

	ImgSetEffectUpdate(IMG_EFFECT_TEXT);
	ScriptSetAct(SCRIPT_ACT_WAIT_KEY);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseWaitPage(void)
{
	TRACEOUT("[y[WXV҂]\n");

	ImgSetEffectUpdate(IMG_EFFECT_TEXT);
	ScriptSetAct(SCRIPT_ACT_WAIT_PAGE);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseWaitStr(void)
{
	u8 cnt = *Script.pCur++;

	TRACEOUT("`摬xw(%d*10ms)\n", cnt);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseWait(void)
{
	u8 cnt = *Script.pCur++;

	TRACEOUT("ԑ҂(%d*10ms)\n", cnt);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseOffset(void)
{
	u8 pos = *Script.pCur++;

	TRACEOUT("`ItZbgw %d\n", pos);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseFlash(void)
{
	TRACEOUT("[tbV]\n");

	ImgSetEffectClear(IMG_EFFECT_FADE_WHITE);
	ImgSetEffectUpdate(IMG_EFFECT_FADE_WHITE);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseShake(void)
{
	TRACEOUT("[uǂvʐU]\n");

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBg2(void)
{
	u8 num1 = ScriptGetMapBg(*Script.pCur++);
	u8 num2 = ScriptGetMapEffect(*Script.pCur++);
	u8 num3 = ScriptGetMapEffect(*Script.pCur++);

	TRACEOUT("[wi[h: %d, %d, %d]\n", num1, num2, num3);

	ImgSetEffectClear(num2);
	ImgSetBg2(num1);
	ImgSetEffectUpdate(num3);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgV(void)
{
	u8 num1 = *Script.pCur++;
	u8 num2 = ScriptGetMapEffect(*Script.pCur++);
	u8 num3 = ScriptGetMapEffect(*Script.pCur++);

	TRACEOUT("[rWA: V%02d.img, %d, %d]\n", num1, num2, num3);

	ImgSetEffectClear(num2);
	ImgSetBgV(num1);
	ImgSetEffectUpdate(num3);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgH(void)
{
	u8 num1 = *Script.pCur++;
	u8 num2 = ScriptGetMapEffect(*Script.pCur++);
	u8 num3 = ScriptGetMapEffect(*Script.pCur++);

	TRACEOUT("[HV[: H%02d.img, %d %d]\n", num1, num2, num3);

	ImgSetEffectClear(num2);
	ImgSetBgH(num1);
	ImgSetEffectUpdate(num3);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseChr(void)
{
	u8 pos   = *Script.pCur++;
	u8 chrNo = *Script.pCur++;

	TRACEOUT("[LύX: %d, C%02X.img]\n", pos, chrNo);

	ImgSetChr2(chrNo, pos);
	ImgSetEffectUpdate(IMG_EFFECT_FADE_MASK);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseChr2(void)
{
	u8 pos   = *Script.pCur++;
	u8 chrNo = *Script.pCur++;

	TRACEOUT("[SL\\: %d, C%02X.img]\n", pos, chrNo);

	ImgSetChrClear(IMG_CHR_TYPE_ALL);
	ImgSetChr2(chrNo, pos);
	ImgSetEffectUpdate(IMG_EFFECT_FADE_MASK);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseBgAndChr(void)
{
	u8 num1 = *Script.pCur++;
	u8 num2 = *Script.pCur++;
	u8 num3 = ScriptGetMapBg(*Script.pCur++);
	u8 num4 = *Script.pCur++;
	u8 num5 = *Script.pCur++;

	TRACEOUT("[witL\\: %d, C%02X.img, S%02d.img, %d, %d]\n", num1, num2, num3, num4, num5);

	ImgSetEffectClear(num4);
	ImgSetBg2(num3);
	ImgSetChr2(num2, num1);
	ImgSetEffectUpdate(num5);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseChrAll(void)
{
	u8 pos1 = *Script.pCur++;
	u8 num1 = *Script.pCur++;
	u8 pos2 = *Script.pCur++;
	u8 num2 = *Script.pCur++;
	u8 pos3 = *Script.pCur++;
	u8 num3 = *Script.pCur++;

	TRACEOUT("[L3l\\: %d, C%02X.img, %d, C%02X.img, %d, C%02X.img]\n", pos1, num1, pos2, num2, pos3, num3);

	ImgSetChr2(num1, pos1);
	ImgSetChr2(num2, pos2);
	ImgSetChr2(num3, pos3);
	ImgSetEffectUpdate(IMG_EFFECT_FADE_MASK);
	BgmPlayNext();

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseSkip3(void)
{
	TRACEOUT("[3]\n");

	Script.pCur += 2;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseAniClaw(void)
{
	TRACEOUT("[S̒]\n");

	AnimeSetType(ANIME_TYPE_CLAW, FALSE);
	ScriptSetAct(SCRIPT_ACT_ANIME);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseUneUne(void)
{
	u8 num1 = *Script.pCur++;
	u8 num2 = *Script.pCur++;

	TRACEOUT("[˂ %d %d]\n", num1, num2);

	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE void ScriptExecParseAniBlood(void)
{
	TRACEOUT("[Ƃт錌]\n");

	AnimeSetType(ANIME_TYPE_BLOOD2, FALSE);
	ScriptSetAct(SCRIPT_ACT_ANIME);

	Script.isLoop = FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE void ScriptExecParseText(void)
{
	u16 buf[512] ALIGN(4);
	u16 cnt = 0;

	do
	{
		buf[cnt++] = (*Script.pCur << 8) | (*(Script.pCur + 1));
		Script.pCur += 2;

		// s`FbN
		if(*Script.pCur == 0xb0)
		{
			Script.pCur++;
		}

	} while(*Script.pCur < 0x20);

	_ASSERT(cnt < 512 && "ScriptExecMsgText buf overflow");


	TextSetBufWork(buf, cnt);
}

