#include "siori.h"
#include "libmy/sram.h"
#include "script.h"
#include "bgm.h"
#include "img.h"

#include "text.h"
#include "anime.h"
#include "history.h"


// SRAM\

// 0x00 - 	"KZ"i2oCgj + o[Wi2oCgj + TCYi2oCgj
// 0x10 - 	ʃtOi4oCgj
// 0x30 - 	iv9j

//---------------------------------------------------------------------------
// OQ
extern ST_SCRIPT Script;
extern ST_BGM Bgm;
extern ST_IMG Img;


//---------------------------------------------------------------------------
ST_SIORI Siori;


//---------------------------------------------------------------------------
EWRAM_CODE void SioriInit(void)
{
	_Memset(&Siori, 0x00, sizeof(ST_SIORI));

	Siori.size = 2 + TEXT_SIORI_CX * 2 + sizeof(ST_SCRIPT) + sizeof(ST_BGM) + sizeof(ST_IMG);

	TRACEOUT("[TCY: 0x%x]\n", Siori.size);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriSaveSig(void)
{
	TRACEOUT("[VOl`]\n");

	SramSeek(0);
	SramWrite8('K');
	SramWrite8('Z');
	SramWrite16(100);
	SramWrite16(Siori.size);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriSaveFlag(void)
{
	TRACEOUT("[tO]\n");

	SramSeek(0x10);

	u8* p;
	u16 i;

	p = (u8*)&Script.flag;
	for(i=0x14; i<=0x1b; i++)
	{
		SramWrite8(*(p+i));
	}

	p = (u8*)&Script.flagEnd;
	for(i=0; i<SCRIPT_MAX_FLAG_END_CNT; i++)
	{
		SramWrite8(*(p+i));
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriLoadFlag(void)
{
	if(SioriIsSram() == FALSE)
	{
		SioriSaveSig();
		SioriSaveFlag();

		TRACEOUT("[N]\n");
		return;
	}


	TRACEOUT("[tOǂݍ]\n");

	SramSeek(0x10);

	u8* pS = SramGetPointer();
	u16 i;

	for(i=0x14; i<=0x1b; i++)
	{
		Script.flag[i] = *pS++;
	}

	for(i=0; i<SCRIPT_MAX_FLAG_END_CNT; i++)
	{
		Script.flagEnd[i] = *pS++;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriSave(u16 no)
{
	_ASSERT(no < SIORI_MAX_CNT);


	TRACEOUT("[@Z[u: %d]\n", no);

	u16  i;
	u8*  p;

	SioriSaveSig();
	SioriSaveFlag();


	SramSeek(0x30 + Siori.size * no);
	SramWrite8('K');
	SramWrite8('V');

	p = (u8*)TextGetSioriStr();
	for(i=0; i<TEXT_SIORI_CX; i++)
	{
		SramWrite8(*p++);
		SramWrite8(*p++);
	}

	p = (u8*)&Script;
	for(i=0; i<sizeof(ST_SCRIPT); i++)
	{
		SramWrite8(*p++);
	}

	p = (u8*)&Bgm;
	for(i=0; i<sizeof(ST_BGM); i++)
	{
		SramWrite8(*p++);
	}

	p = (u8*)&Img;
	for(i=0; i<sizeof(ST_IMG); i++)
	{
		SramWrite8(*p++);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE bool SioriLoad(u16 no)
{
	TRACEOUT("[@[h: %d]\n", no);

	if(SioriIsSram() == FALSE)
	{
		return FALSE;
	}


	SramSeek(0x30 + Siori.size * no);
	u8* pS = SramGetPointer();
	u8* pD;
	u16 i;

	if(*(pS+0) != 'K' || *(pS+1) != 'V')
	{
		return FALSE;
	}
	pS += 2 + (TEXT_SIORI_CX * 2);


	pD = (u8*)&Script;
	for(i=0; i<sizeof(ST_SCRIPT); i++)
	{
		*pD++ = *pS++;
	}

	pD = (u8*)&Bgm;
	for(i=0; i<sizeof(ST_BGM); i++)
	{
		*pD++ = *pS++;
	}

	pD = (u8*)&Img;
	for(i=0; i<sizeof(ST_IMG); i++)
	{
		*pD++ = *pS++;
	}


	// A܂

	// L̃tO
	SioriLoadFlag();

	// XNvg
	if(Script.act == SCRIPT_ACT_EVENT || Script.actTmp == SCRIPT_ACT_SELECT)
	{
		Script.act = SCRIPT_ACT_EVENT;
		Script.pCur = Script.pEventOld;
	}
	else
	{
		Script.act = SCRIPT_ACT_MSG;
		Script.pCur = Script.pMsgOld;
	}

	// BGM
	BgmPlayRestart();

	// 
	TextSetClearNoBuf();
	ImgSetEffectClear(IMG_EFFECT_FADE_BLACK);
	ImgSetEffectUpdate(IMG_EFFECT_FADE_BLACK);

	HistoryInit();
	TextInit();

	return TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriSavePrev(void)
{
	SioriSave(SIORI_MAX_CNT - 1);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SioriLoadPrev(void)
{
	SioriLoad(SIORI_MAX_CNT - 1);
}
//---------------------------------------------------------------------------
EWRAM_CODE char* SioriGetName(u16 no)
{
	SramSeek(0x30 + Siori.size * no);
	u8* p = SramGetPointer();

	if(*(p+0) != 'K' || *(p+1) != 'V')
	{
		return "|||||||||||";
	}

	return (char*)p + 2;
}
//---------------------------------------------------------------------------
EWRAM_CODE bool SioriIsSram(void)
{
	SramSeek(0);

	if(SramRead8() != 'K') return FALSE;
	if(SramRead8() != 'Z') return FALSE;

	return TRUE;
}
