#import "MOXAudio.h"

@implementation MOXAudio

/**
 * Хå
 * ХåեФͤꤹ򵭽Ҥɬפ
 * buffer[play] Фơ buffer_size ޤǤΥǡꤹ롣
 */
- (void)callback { /* virtual */ }

/**
 * Хå
 * սϿ줿ХåνԤ
 */
- (void)base_callback
{
	if (!opened)
		return;

	// ¹
	{
		SndCommand cmd;
		header.samplePtr = buffer[play];
		cmd.cmd    = bufferCmd;
		cmd.param1 = 0;
		cmd.param2 = (long)&header;
		SndDoCommand(channel, &cmd, 0);
	}
	
	// Хåեڤؤ
	play = 1 - play;

	// Хåեõ
	memset(buffer[play], 0, buffer_size);

	// Хåե
	if (!paused) {
		[lock lock];
		[self callback];
		[lock unlock];
	}

	// ΥХå
	if (opened) {
		SndCommand cmd;
		cmd.cmd    = callBackCmd;
		SndDoCommand(channel, &cmd, 0);
	}
}

// Хåѥץ
static void 
callbackProc(SndChannel *ch, SndCommand *cmd)
{
	[(MOXAudio*)ch->userInfo base_callback];
}

/**
 * ˥饤
 * ľ˱սϤƥݡ֤ˤʤ
 *
 * @param format   
 * @param freq     ȿ
 * @param channels ͥ
 * @param samples  ץǡ
 */
- (int)init:(AudioFormat)format freq:(int)freq channels:(int)channels samples:(int)samples 
{
	int i;

	// ƥץξϤäλ
	if (opened) {
		[self stop];
	}

	// å
	lock = [[NSLock alloc] init];

	header.numChannels = channels;
    header.sampleSize  = (format & 0xff) * 8;
    header.sampleRate  = freq << 16;
    header.numFrames   = samples;
    header.encode      = cmpSH;

    // С 
	// ǥեȤ MSB 餷
    switch (format) {
	case AUDIO_S16LSB:
        header.compressionID = fixedCompression;
        header.format = k16BitLittleEndianFormat;
		break;
	default:
		header.compressionID = notCompressed;
    }

    // Хåե
	buffer_size = (format & 0xff) * samples * channels;
	for (i=0; i<2; i++) {
		if ((buffer[i] = malloc (sizeof(buffer[0]) * buffer_size)) == NULL) {
			goto errend;
		}
		memset(buffer[i], 0, buffer_size);
	}

	// ͥ
	if ((channel = malloc(sizeof *channel)) == NULL) {
		goto errend;
	}

    channel->userInfo = (long)self;
    channel->qLength  = 128;
    if (SndNewChannel(&channel, 
					  sampledSynth, 
					  (channels >= 2) ? initStereo : initMono,
					  NewSndCallBackUPP(callbackProc)) != noErr) {
        fprintf(stderr, "failed to create audio channel");
        goto errend;
    }

	opened = YES;
	paused = YES;

   	// Хå
	{
		SndCommand cmd;
		cmd.cmd = callBackCmd;
		SndDoCommand(channel, &cmd, 0);
	}

	return 0;
	
 errend:
	for (i=0;i<2;i++)
		free(buffer[i]);
	free(channel);
	return -1;
}

/**
 * Хåեå
 */
- (void)lock
{
	[lock lock];
}

/**
 * ХåեΥå
 */
- (void)unlock
{
	[lock unlock];
}

/**
 * վ֤֤
 */
- (AudioStatus)status
{
	return opened ? (paused ? AUDIO_PAUSED :  AUDIO_PLAYING) : AUDIO_STOPPED;
}

/**
 * դߤ
 */
- (void)pause:(BOOL)on
{
	paused = on;
}

/**
 * դߤ롣
 */
- (void)stop
{
	if (opened) {
		int i;
		opened = NO;
		
		// ͥ˴
		SndDisposeChannel(channel, true);
		channel = NULL;
		
		// Хåե˴
		for (i=0; i<2; i++) {
			free(buffer[i]);
			buffer[i] = NULL;
		}

		// å˴
		[lock release];
	}
}

/**
 * ǥȥ饯
 */
- (void)dealloc 
{
	if (opened) 
		[self stop];
	[super dealloc];
}

@end
